/*
	Program dela skalarni produkt dveh FP vektorjev z OpenMP
*/

#include <stdio.h>
#include "omp.h"

#define N 100000000						// stevilo elementov v vektorju

double Array1[N];
double Array2[N];
double dotproduct = 0.0;

void main(void) 
{
	int i;
	double start, end;
   
	// inicializiraj oba vekorja:
	for (i = 0; i < N; i++) 
	{
		Array1[i] = 1.0 + i/100;
		Array2[i] = 1.0 + i/100;
	}

	// skalarni produkt med dvema kosoma vektorjev
	start = omp_get_wtime();
//	#pragma omp parallel for	(1)
//	#pragma omp parallel for reduction(+:dotproduct) // (4)
	for (i = 0; i<N; i++) 
//		#pragma omp critical // (2)
//		#pragma omp atomic   // (3)		
		dotproduct += Array1[i] * Array2[i];
	end = omp_get_wtime();
	printf("Rezultat: %.2f, cas = %f\n", dotproduct, end-start);
}
