/*
	Program dela skalarni produkt dveh FP vektorjev z OpenMP
*/

#include <stdio.h>

#define N 100000000						// stevilo elementov v vektorju

double Array1[N];
double Array2[N];
double dotproduct = 0.0;

void main(void) 
{
	int i;
	double start, end;
   
	// inicializiraj oba vekorja:
	for (i = 0; i < N; i++) 
	{
		Array1[i] = 1.0 + i/100;
		Array2[i] = 1.0 + i/100;
	}

	// skalarni produkt med dvema kosoma vektorjev
	for (i = 0; i<N; i++) 
		dotproduct = dotproduct + Array1[i] * Array2[i];
	printf("Rezultat: %.2f\n", dotproduct);
}
